apiVersion: batch/v1
kind: Job
metadata:
  name: {{ include "common.fullname" . }}-upgrade
  labels:
    {{- include "common.labels" . | nindent 4 }}
  annotations:
    "helm.sh/hook": pre-upgrade
    "helm.sh/hook-weight": "0"
    "helm.sh/hook-delete-policy": before-hook-creation,hook-succeeded
spec:
  template:
    metadata:
      name: {{ include "common.fullname" . }}-upgrade
      {{- with .Values.podAnnotations }}
      annotations:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      labels:
        {{- include "common.selectorLabels" . | nindent 8 }}
    spec:
      restartPolicy: Never
      containers:
        - name: {{ .Chart.Name }}-upgrade
          securityContext:
            {{- toYaml .Values.securityContext | nindent 12 }}
          image: "{{ .Values.image.repository }}:{{ .Values.image.tag | default .Chart.AppVersion }}"
          imagePullPolicy: {{ .Values.image.pullPolicy }}
          command: ["./listmonk", "--upgrade", "--yes"]
          env:
            {{- if .Values.default_admin.username }}
            - name: LISTMONK_app__admin_username
              value: {{ .Values.default_admin.username | quote }}
            {{- end }}
            {{- if .Values.default_admin.password }}
            - name: LISTMONK_app__admin_password
              value: {{ .Values.default_admin.password | quote }}
            {{- end }}
            {{- if .Values.database.host }}
            - name: LISTMONK_db__host
              value: {{ .Values.database.host | quote }}
            {{- end }}
            {{- if .Values.database.service.port }}
            - name: LISTMONK_db__port
              value: {{ .Values.database.service.port | quote }}
            {{- end }}
            {{- if .Values.database.username }}
            - name: LISTMONK_db__user
              value: {{ .Values.database.username | quote }}
            {{- end }}
            {{- if .Values.database.password }}
            - name: LISTMONK_db__password
              value: {{ .Values.database.password | quote }}
            {{- end }}
            {{- if .Values.database.name }}
            - name: LISTMONK_db__database
              value: {{ .Values.database.name | quote }}
            {{- end }}
            {{- if .Values.database.SSL }}
            - name: LISTMONK_db__ssl_mode
              value: {{ .Values.database.SSL | quote }}
            {{- end }}
          ports:
            - name: http
              containerPort: {{ .Values.service.port }}
              protocol: TCP
          livenessProbe:
            httpGet:
              path: /
              port: http
          readinessProbe:
            httpGet:
              path: /
              port: http
          resources:
            {{- toYaml .Values.resources | nindent 12 }}
